using System;
using System.Collections.Generic;
using System.Linq;
using Microsoft.Xna.Framework;

using Microsoft.Xna.Framework.Audio;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.GamerServices;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Media;
using ScreenManager;
using LabirintGUI.Screens;
using LabyrinthProject;

namespace LabirintGUI
{
    /// <summary>
    /// This is the main type for your game
    /// </summary>
    public class GUIGame : Microsoft.Xna.Framework.Game
    {
        GraphicsDeviceManager graphics;
        public static LabyrinthProject.LabyrinthGame game;

        SoundEffect musicMenu1;
        SoundEffectInstance musicMenu1Instance;
        SoundEffect musicMenu2;
        SoundEffectInstance musicMenu2Instance;
        public static Queue<SoundEffectInstance> musicMenuQueue;

        public GUIGame()
        {
            graphics = new GraphicsDeviceManager(this);
          

            graphics.PreferredBackBufferWidth = GraphicsAdapter.DefaultAdapter.CurrentDisplayMode.Width;
            graphics.PreferredBackBufferHeight = GraphicsAdapter.DefaultAdapter.CurrentDisplayMode.Height;
            Properties.resolution.X = graphics.PreferredBackBufferWidth;
            Properties.resolution.Y = graphics.PreferredBackBufferHeight;
            graphics.PreferMultiSampling = false;
            graphics.IsFullScreen = true;

            musicMenuQueue = new Queue<SoundEffectInstance>();
            Content.RootDirectory = "Content";
        }

        /// <summary>
        /// Allows the game to perform any initialization it needs to before starting to run.
        /// This is where it can query for any required services and load any non-graphic
        /// related content.  Calling base.Initialize will enumerate through any components
        /// and initialize them as well.
        /// </summary>
        protected override void Initialize()
        {
            // TODO: Add your initialization logic here

            Properties.soundOn = false;
            Properties.musicOn = false;
            Properties.resolution = new Vector2(GraphicsAdapter.DefaultAdapter.CurrentDisplayMode.Width, GraphicsAdapter.DefaultAdapter.CurrentDisplayMode.Height);
            Properties.fullScreenOn = false;

            SCREEN_MANAGER.add_screen(new MainScreen(GraphicsDevice));
            SCREEN_MANAGER.add_screen(new NewGameScreen1stPlayer(GraphicsDevice));
            SCREEN_MANAGER.add_screen(new NewGameScreen2ndPlayer(GraphicsDevice));
            SCREEN_MANAGER.add_screen(new HelpScreen(GraphicsDevice));
            SCREEN_MANAGER.add_screen(new SettingsScreen(GraphicsDevice));
            SCREEN_MANAGER.add_screen(new AboutScreen(GraphicsDevice));
            game = new LabyrinthProject.LabyrinthGame((int)Properties.resolution.X, (int)Properties.resolution.Y, Properties.fullScreenOn, LabyrinthProject.GraphicStyle.Red, Properties.soundOn, Properties.musicOn, 1, this, graphics);
            SCREEN_MANAGER.add_screen(game);

            SCREEN_MANAGER.goto_screen("main");

            base.Initialize();
        }

        /// <summary>
        /// LoadContent will be called once per game and is the place to load
        /// all of your content.
        /// </summary>
        protected override void LoadContent()
        {
            
            //musicMenu1 = this.Content.Load<SoundEffect>("Music/Menu1");
            //musicMenu1Instance = musicMenu1.CreateInstance();
            //musicMenu2 = this.Content.Load<SoundEffect>("Music/Menu2");
            //musicMenu2Instance = musicMenu2.CreateInstance();
            //musicMenuQueue.Enqueue(musicMenu1Instance);
            //musicMenuQueue.Enqueue(musicMenu2Instance);
            //this.MainSpriteBatch = new SpriteBatch(graphics.GraphicsDevice);
            // this.Background  = Content.Load<Texture2D>(@"main-cb");
            SCREEN_MANAGER.Init(this);     
 
           
        }

        /// <summary>
        /// UnloadContent will be called once per game and is the place to unload
        /// all content.
        /// </summary>
        protected override void UnloadContent()
        {
            // TODO: Unload any non ContentManager content here
        }

        /// <summary>
        /// Allows the game to run logic such as updating the world,
        /// checking for collisions, gathering input, and playing audio.
        /// </summary>
        /// <param name="gameTime">Provides a snapshot of timing values.</param>
        protected override void Update(GameTime gameTime)
        {
           // PlayMusic();
            // Allows the game to exit
            if (GamePad.GetState(PlayerIndex.One).Buttons.Back == ButtonState.Pressed)
                this.Exit();
            

            // TODO: Add your update logic here
            SCREEN_MANAGER.Update(gameTime);
            base.Update(gameTime);
        }

        private void PlayMusic()
        {
            if (musicMenuQueue.Count != 0)
            {
                SoundEffectInstance music = musicMenuQueue.Peek();
                if (music.State == SoundState.Stopped)
                {
                    music = musicMenuQueue.Dequeue();
                    musicMenuQueue.Enqueue(music);
                    music = musicMenuQueue.Peek();
                    music.Volume = 0.5f;
                    music.Play();
                }
                else if (music.State == SoundState.Playing)
                {
                    music.Play();
                }
            }
        }

        /// <summary>
        /// This is called when the game should draw itself.
        /// </summary>
        /// <param name="gameTime">Provides a snapshot of timing values.</param>
        protected override void Draw(GameTime gameTime)
        {
            SCREEN_MANAGER.Draw(gameTime);
            base.Draw(gameTime);
        }
    }
}
